//#ifdef EOS500D

/* 

Die Signale auerhalb des LV sind sehr hnlich oder identisch zu
denen der 550D/600D.

On entering LV the 500D issues a pulse on Coil 2
while Coil1 is inactive.

*******************************************************************
The following timings are based on measurements carried
 out by Souhayle EL ABDI (elabdisouhayle at gmail.com)
******************************************************************/


// Coil 1 Timing:
// - (Re)Enter LV: --
// - Leave LV: 33 ms
//
// Coil-2 Timing
// - Das Shoot C2_Hi kommt bei 79 ms.
// - Beim LV-Start kommt C2_Hi bei 151 ms.
// 

// Shoot
//
ACTION_TABLE_P(c1_L_Start) = {			// Coil aktiv
	{0 ms,   OPT1, LOW  }, // 0
	{0 ms,   OPT2, LOW  }, // 1
	{23 ms,  ROT1, HIGH }, // 2
	{40 ms,  ROT2, LOW  }, // 3
	{51 ms,  ROT2, HIGH }, // 4
	{61 ms,  ROT3, LOW  },
	HALT_ACTION,
};


// Fortsetzung des regulren Timings nach Coil-1/2 Hi
//
ACTION_TABLE_P(c2_H_FinishShoot) = {		// Coil 2 wird inaktiv
        {1 ms,    OPT2, HIGH },//:
	{6 ms,    OPT2, HIGH },	// -> Curtain ffnet und nach 6 ms geht OPT2 Hi. Wenn bei sehr kurzen 
				//  Belichtungen (<6ms, 1/200) C1 zuvor Hi wird, wird die Aktion vorgezogen.
				//  Tatschlich ist es auch ok, OPT2_H sofort nach C2_H auszufhren.
	LONGWAIT_ACTION,	// hier warten, bis Coil 1 Hi wird und den Ablauf fortsetzt
//#define c1_H_FinishShoot (c2_H_FinishShoot + 3)	
	// Coil 1 wird inaktiv
	// Curtain von Coil 2 hat schon vorher geffnet und 7 ms danach ging
	// OPT2 Hi - falls die Belichtung > 7 ms war. 
	{ 4 ms,  OPT1, HIGH },
	{ 5 ms,  OPT1, LOW  },
	{ 7 ms,  OPT1, HIGH },
	{ 34 ms, ROT3, HIGH },
	{ 61 ms, ROT4, LOW  },
	{106 ms, ROT4, HIGH },
	{107 ms, ROT1, LOW  },
	{111 ms, OPT1, LOW  }, // unsichtbar wg. OptPwr aus
	{111 ms, OPT2, LOW  }, // unsichtbar wg. OptPwr aus
	STOP_ACTION,
};


// Auslsen im LV fhrt zu 3 Aktionen:
// - Coil 1 fr 33 ms mit anschlieender Motorbewegung in den
//   Zustand auerhalb LV (c1_x_LeaveLV)
// - Coil 1+2 wie Shoot auerhalb LV 
// - ReenterLV, identisch mit EnterLV
//
ACTION_TABLE_P(c1_L_LeaveLV) = {			// Coil 1 aktiv im LV
	{0 ms,   OPT1, LOW  }, // sollte schon anliegen
	{0 ms,   OPT2, HIGH }, //   ""
	{21 ms,  ROT2, HIGH }, // 4
	{32 ms,  ROT3, LOW  },
	HALT_ACTION,           // bis C1_H warten
};

// .. weiter (wie c1_H_FinishShoot):
//
ACTION_TABLE_P(c1_H_LeaveLV) = {
	{ 4 ms,  OPT1, HIGH },
	{ 5 ms,  OPT1, LOW  },
	{ 7 ms,  OPT1, HIGH },
	{ 27 ms, ROT3, HIGH },
	{ 54 ms, ROT4, LOW  },
	{106 ms, ROT4, HIGH },
	{107 ms, ROT1, LOW  },
	{111 ms, OPT1, LOW  }, // unsichtbar wg. OptPwr aus
	{111 ms, OPT2, LOW  }, // unsichtbar wg. OptPwr aus
	STOP_ACTION,
};

/* -> c1_L_Start
// Teil 2 des Auslsens im LV: Coil 1+2 aktiv im LV
//
ACTION_TABLE_P(c1_L_StartInLV) = {
	{23 ms,  ROT1, HIGH }, // 2
	{40 ms,  ROT2, LOW  }, // 3
	{51 ms,  ROT2, HIGH }, // 4
	{61 ms,  ROT3, LOW  },
	HALT_ACTION,
};

// .. Fortsetzung nach C1H
ACTION_TABLE_P(c2_H_FinishLVShoot) = {		// Coil 2 wird inaktiv
	{6 ms,    OPT2, HIGH },	// -> Curtain ffnet und nach 6 ms geht OPT2 Hi. 
	LONGWAIT_ACTION,
#define c1_H_FinishLVShoot (c2_H_FinishLVShoot + 2)	
	// Coil 1 wird inaktiv
	// Curtain von Coil 2 hat schon vorher geffnet und 7 ms danach ging
	// OPT2 Hi - falls die Belichtung > 7 ms war. 
	{ 0 ms,  OPT2, HIGH }, // (falls t < 6ms war)
	{ 4 ms,  OPT1, HIGH },
	{ 5 ms,  OPT1, LOW  },
	{ 7 ms,  OPT1, HIGH },
	{ 30 ms, ROT3, HIGH },
	{ 60 ms, ROT4, LOW  },
	{110 ms, ROT4, HIGH },
	{111 ms, ROT1, LOW  },
	{111 ms, OPT1, LOW  }, // unsichtbar wg. OptPwr aus
	//{112 ms, OPT2, LOW  }, // unsichtbar wg. OptPwr aus
	{123 ms, ROT1, HIGH },	// Zeit unklar, fehlt im Log
	{188 ms, ROT2, LOW  },	// Zeit unklar, fehlt im Log
	//{189 ms, OPT2, HIGH }, // unsichtbar wg. OptPwr aus
	STOP_ACTION,
};
*/
  
// LV wird mit Coil 2 allein gestartet
// (startet wie Shoot, aber langsamer, wird mit C2_H fortgesetzt)
ACTION_TABLE_P(c2_L_EnterLV) = {
	{0 ms,   OPT1, LOW  }, // 0
	{0 ms,   OPT2, LOW  }, // 1
	{85 ms,  ROT1, HIGH }, // 2
	{150 ms, ROT2, LOW  }, // 3
	HALT_ACTION,
};
  
// Coil 2 lst nach LV-Start
ACTION_TABLE_P(c2_H_EnterLV) = {
	{6 ms,   OPT2, HIGH},
	STOP_ACTION,
};


// Erste emuAction Liste auswhlen fr ein Coil-Start Ereignis
// Wird sowohl fr Coil 1 als auch Coil 2 aufgerufen!
//
inline const emuAction* SelectStartAction()
{
  // Nur Coil 1: LeaveLV vor ShootInLV oder LeaveLV
  // Nur Coil 2: EnterLV, ReEnterLV
  // Beide     : Shoot oder ShootInLV Teil 2
  //
  if (digitalRead(TRIGGER1) == TRIGGER1_ACTIVE) {   // Coil 1 ist aktiv
    if (digitalRead(TRIGGER2) == TRIGGER2_ACTIVE) { // Coil 1+2:
      PRINTLN("c1_L_Start");
      return c1_L_Start;
    }
    else {					    // nur Coil 1: LeaveLV 
      PRINTLN("c1_L_LeaveLV");
      return c1_L_LeaveLV;
    }
  }
  else {					    // nur Coil 2: (Re)EnterLV
    PRINTLN("c2_L_EnterLV");
    return c2_L_EnterLV;
  }
}


// Nchste emuAction Liste auswhlen fr die Fortsetzung eines Coil-Start Ereignisses,
//  das jetzt nach dt Millisekunden durch ein Coil2-Ende Signal abgeschlossen wurde.
//
inline const emuAction* SelectFinishAction(unsigned long dt)
{
  dt = dt;
  if (actionPtr == c2_L_EnterLV) { // oder: if (dt > 100 ms)
    PRINTLN("c2_H_EnterLV");
    return c2_H_EnterLV;
  }
  else {																	// (700D 68 ms, 600D 77 ms:) nicht-LV-Shoot
    PRINTLN("c2_H_FinishShoot");
    return c2_H_FinishShoot;
  }
}

//#endif // EOS500D --------------------------------------------
