//#if defined(EOS50D)

#undef	MR3_INIT
#define	MR3_INIT  LOW	// abweichend von den Voreinst. für die 6D

// Zwischen den Shutter-Anschlüssen 9 und 10 hängt ein Temperatursensor, vermutlich ein NTC
//  mit einem Widerstand von 1.2 kOhm bei RT. Ohne diesen meldet die Kamera, die interne 
//  Temperatur sei zu hoch. Mit einem Ersatzwiderstand von 1k2 ist alles gut.


ACTION_TABLE_P(c1_L_Start) = {		// Coil 1 (und 2) aktiv
	{0 ms,   OPT1, HIGH },
	{0 ms,   OPT2, HIGH },
	{0 ms,   ROT1, LOW  },
	{ 5 ms,  MR3 , HIGH  },
	{ 9 ms,  MR3 , HIGH },
	{12 ms,  MR1 , LOW  },
	{13 ms,  ROT1, HIGH },
	{33 ms,  ROT2, LOW  },
	// Hier folgt beim Shoot nach 50 bis 60 ms C2_H, das die Umschaltung auf c2_H_FinishShoot
	//  triggert. Beim Re-Enter des LV vergehen 240 ms für Zeiten < 1s.
	//  Für t > 1s und Bulb dauert es im LV1 und LV2 noch 860 ms, weil der Motor anhält: Dann
	//  sind die gerade ausgeführten ROT1_H und ROT2_L noch gar nicht fällig, sondern werden
	//  erst bei 514 und 535 ms erwarten. Deshalb nach 500  ms ROT1+2 zurücknehmen und 
	//  nochmal ausführen. Das Nachholen dieser Sequenz via HALT_ACTION scheint nicht zu stören.
	//  (Stattdessen könnte hier vmtl. auch STOP_ACTION verwendet werden.)
	{500 ms,  ROT1, LOW  },
	{500 ms,  ROT2, HIGH  },
	{514 ms,  ROT1, HIGH  },
	{535 ms,  ROT2, LOW  },
	HALT_ACTION,		// weiter gehts wenn C2 Hi die Belichtung startet (bei der Spiegelvorauslösung hält der Ablauf hier an)
};


// Fortsetzung des regulären Shoot-Timings nach Coil-2 Hi
//
ACTION_TABLE_P(c2_H_FinishShoot) = {			// Coil 2 wird inaktiv
	{ 3 ms,  OPT2, LOW  },
	{ 5 ms,  OPT2, HIGH },
	{ 6 ms,  OPT2, LOW  },
	LONGWAIT_ACTION,	// hier warten, bis Coil 1 Hi wird und die Belichtung beendet
#define c1_H_FinishShoot (c2_H_FinishShoot + 4)	
	// Coil 1 wird inaktiv: 
	{ 3 ms,  OPT1, LOW  },
	{ 5 ms,  OPT1, HIGH },	  // tritt evtl. nicht immer auf
	{ 6 ms,  OPT1, LOW  },	  //   "
	{10 ms,  MR1 , HIGH }, 
	{24 ms,  ROT2, HIGH },
	{91 ms,  MR3 , LOW  },
	{97 ms,  MR2 , LOW  },

	{46 ms,  OPT2, HIGH },
	{54 ms,  OPT1, HIGH },
	{56 ms,  OPT2, LOW  },
	{60 ms,  OPT2, HIGH },
	//Der folgende Puls ist nur im LV da, wird aber nicht gebraucht und auch im normalen Shoot ignoriert:
	//{66 ms,  OPT1, LOW  },
	//{77 ms,  OPT1, HIGH },
	{84 ms,  ROT1, LOW  },

	STOP_ACTION,
};
//
// Das einfache Shoot-Timing funktioniert auch für Start und Ende des LV und für
//  Shoot im LV ohne Leise-Modus. Für Shoot im Leise-Modus 1 und 2 für
//  Zeiten >= 1 Sekunde oder Bulb (egal wie lang) folgt Error 20.
//  Hier macht der Motor eine Pause, so dass Rot1 und Rot2 nicht schon
//   13 ms nach C1_H kommen, sondern erst nach 514 ms. Das ist im 
//   Shoot-Timing oben nachgebildet, so dass keine speziellen LV-Sequenzen
//   benötigt werden!
// Spiegelvorauslösung ist für normales Shoot ok, gibt bei Shoot im LV aber Err20.
//
/*
// Start nach Shoot im LV:  Coil 2 ohne Coil 1 aktiv
//
ACTION_TABLE_P(c2_L_StartInLVForLV) = {	
	HALT_ACTION,		// weiter gehts mit C2 Hi
};


//
// Start in LV: Coil 1+2 aktiv. Wird für LV-Shoot und LV-Stop ausgef.
ACTION_TABLE_P(c1_L_StartInLV) = {			// Coil 2 aktiviert im LV
	HALT_ACTION,
};

// Fortsetzung des LVShoot-Timings nach Coil-1/2 Hi
//
ACTION_TABLE_P(c2_H_FinishLVShoot) = {			// Coil 2 wird inaktiv
	LONGWAIT_ACTION,				// hier warten, bis Coil 1 Hi wird und den Ablauf fortsetzt
#define c1_H_FinishLVShoot (c2_H_FinishLVShoot + 1)	
	STOP_ACTION,
};

// Start des LV 
ACTION_TABLE_P(c2_H_EnterLV) = {	
	STOP_ACTION,
};
#define c1_H_EnterLV c2_H_EnterLV

ACTION_TABLE_P(c2_H_LeaveLV) = {
	STOP_ACTION,						// fertig
};
#define c1_H_LeaveLV	c2_H_LeaveLV		// ohne Coil2: für Coil1 identisch
*/

#define	c1_H_FinishLVShoot  c1_H_FinishShoot
#define	c1_H_LeaveLV	    c1_H_FinishShoot
#define	c1_H_EnterLV	    c1_H_FinishShoot


#define IsInWindow_LVShoot(dt)   false	//(dt >= LoLIMIT_C2_LVSHOOT)
#define IsInWindow_EnterLV(dt)   false	//(dt <= HiLIMIT_C2_ENTER_LV  &&  dt >= HiLIMIT_C2_LEAVE_LV)
#define IsInWindow_ReEnterLV(dt) false	//(dt <= HiLIMIT_C2_REENTER_LV  &&  dt >= HiLIMIT_C2_LEAVE_LV)
#define IsInWindow_LeaveLV(dt)   false	//(dt <= HiLIMIT_C1_LEAVE_LV)

// Erste emuAction Liste auswählen für ein Coil-Start Ereignis
//
inline const emuAction* SelectStartAction()
{
  return c1_L_Start;
}

// Nächste emuAction Liste auswählen für die Fortsetzung eines Coil-Start Ereignisses,
//  das jetzt nach dt Millisekunden durch ein Coil-Ende Signal abgeschlossen wurde.
//
inline const emuAction* SelectFinishAction(unsigned long )
{
  // Coil-2 Timing der 50D:
  // - Das reguläre C2_Hi kommt bei 53-54 ms, im LV große Unterschiede je nach Modus.
  // - Beim LV-Start kommt C2_Hi nach 51 ms oder 54 ms (LV1).
  // - Am Ende des LV ist der C2 Puls ca. 240 ms breit
  //
  return c2_H_FinishShoot;
}

//#endif // EOS50D --------------------------------------------
