///////////////////////////////////////////////////////////////////////////
// Canon EOS Shutter-Emulation on Arduino (Nano / Pro Mini, / ...)
//
//       25.1.2017 - 31.01.2025                       Erwin Lotter
//

// EOS 500D emulation core, to be included from ShutterEmuEOS.ino

  if (triggerEvent == evCoil1Start) {        // Start-Flanke (Coil 1) aktiviert:
    InitEvent();
    stateIndex = 0;
    actionPtr = SelectStartAction();
    NotifyIntervalTimer(actionPtr == c1_L_Start);
  } // if (triggerEvent == evCoil1Start) -----------------------------------------------
  else if (triggerEvent == evCoil1Stop) { // Coil 1 wurde inaktiv (C1_H):
    //
    // Falls eine Belichtung stattfand, sollte aktuell ein bei C2_H gestartetes LONGWAIT 
    //  laufen (entweder in c2_H_FinishShoot oder in c2_H_FinishLVShoot).
    // Das wird jetzt beendet (und die davor noch anstehenden Signale
    //  werden generiert).
    //
    if (prevEvent == evCoil2Stop) {
      ContinueActions();	// Actionliste bis WAIT oder LONGWAIT abarbeiten
      PRINTLN("c1_H_FinishShoot");
    }
    else {
      // Coil 1 H ohne Coil 2 muss LeaveLV gewesen sein
      //
      actionPtr = c1_H_LeaveLV;
      PRINTLN("c1_H_LeaveLV");
      stateIndex = 0;
    }
    InitEvent();
  } // if (triggerEvent == evCoil1Stop) -----------------------------------------------------
  //
  //
  else if (triggerEvent == evCoil2Stop) {        // Coil-2 deaktiviert: Shutter öffnet
    unsigned long dt = triggerTime - timingZero;		// Coil-2 Pulsdauer
    actionPtr = SelectFinishAction(dt);
    stateIndex = 0;
    InitEvent();
  } // if (triggerEvent == evCoil2Stop) ----------------------------------------
